Index: patches.ent
===================================================================
--- patches.ent	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ patches.ent	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,5 +1,9 @@
-<?xml version="1.0" encoding="ISO-8859-1"?>
+<?xml version="1.0" encoding="UTF-8"?>
 
 <!-- Start of Common Patches -->
+
+<!ENTITY bash-upstream-fixes-patch "bash-&bash-version;-upstream_fixes-1.patch">
+<!ENTITY bash-upstream-fixes-patch-md5 "2d1691a629c558e894dbb78ee6bf34ef">
+<!ENTITY bash-upstream-fixes-patch-size "5.9 KB">
 
 <!ENTITY bzip2-docs-patch "bzip2-&bzip2-version;-install_docs-1.patch">
@@ -14,20 +18,20 @@
 <!ENTITY glibc-fhs-patch-md5 "9a5997c3452909b1769918c759eff8a2">
 <!ENTITY glibc-fhs-patch-size "2.8 KB">
-
-<!ENTITY glibc-upstream-fixes-patch "glibc-&glibc-version;-upstream_fixes-3.patch">
-<!ENTITY glibc-upstream-fixes-patch-md5 "545977e0b5c341ba945cf4b5de92f1e2">
-<!ENTITY glibc-upstream-fixes-patch-size "28 KB">
-
-<!ENTITY grub-upstream-fixes-patch "grub-&grub-version;-upstream_fixes-1.patch">
-<!ENTITY grub-upstream-fixes-patch-md5 "da388905710bb4cbfbc7bd7346ff9174">
-<!ENTITY grub-upstream-fixes-patch-size "8 KB">
-
+<!--
+<!ENTITY glibc-upstream-fixes-patch "glibc-&glibc-version;-upstream_fixes-4.patch">
+<!ENTITY glibc-upstream-fixes-patch-md5 "66e843b00688c641c9bdda684db45b43">
+<!ENTITY glibc-upstream-fixes-patch-size "36 KB">
+-->
 <!ENTITY kbd-backspace-patch "kbd-&kbd-version;-backspace-1.patch">
 <!ENTITY kbd-backspace-patch-md5 "f75cca16a38da6caa7d52151f7136895">
 <!ENTITY kbd-backspace-patch-size "12 KB">
 
-<!ENTITY readline-fixes-patch "readline-&readline-version;-upstream_fix-1.patch">
-<!ENTITY readline-fixes-patch-md5 "dd1764b84cfca6b677f44978218a75da">
-<!ENTITY readline-fixes-patch-size "1.3 KB">
+<!ENTITY pkgconf-upstream-fix-patch "pkgconf-&pkgconf-version;-upstream_fix-1.patch">
+<!ENTITY pkgconf-upstream-fix-patch-md5 "77d5bb10840724a0e3dc08efee548363">
+<!ENTITY pkgconf-upstream-fix-patch-size "4 KB">
+
+<!ENTITY readline-fixes-patch "readline-&readline-version;-upstream_fixes-3.patch">
+<!ENTITY readline-fixes-patch-md5 "9ed497b6cb8adcb8dbda9dee9ebce791">
+<!ENTITY readline-fixes-patch-size "13 KB">
 
 <!ENTITY sysvinit-consolidated-patch "sysvinit-&sysvinit-version;-consolidated-1.patch">
Index: stylesheets/dump-commands.xsl
===================================================================
--- stylesheets/dump-commands.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/dump-commands.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,7 +1,7 @@
-<?xml version="1.0"?>
+<?xml version="1.0" encoding="UTF-8"?>
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
-    xmlns:exsl="http://exslt.org/common"
-    extension-element-prefixes="exsl"
-    version="1.0">
+                xmlns:exsl="http://exslt.org/common"
+                extension-element-prefixes="exsl"
+                version="1.0">
 
 <!-- XSLT stylesheet to extract commands from [B,H]LFS books. -->
Index: stylesheets/lfs-chunked.xsl
===================================================================
--- stylesheets/lfs-chunked.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-chunked.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
Index: stylesheets/lfs-nochunks.xsl
===================================================================
--- stylesheets/lfs-nochunks.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-nochunks.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
Index: stylesheets/lfs-pdf.xsl
===================================================================
--- stylesheets/lfs-pdf.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-pdf.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
Index: stylesheets/lfs-xsl/chunk-master.xsl
===================================================================
--- stylesheets/lfs-xsl/chunk-master.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-xsl/chunk-master.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
Index: stylesheets/lfs-xsl/chunk-slave.xsl
===================================================================
--- stylesheets/lfs-xsl/chunk-slave.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-xsl/chunk-slave.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
@@ -11,6 +11,11 @@
   <xsl:import href="http://docbook.sourceforge.net/release/xsl/current/xhtml/docbook.xsl"/>
 
-  <!-- Use ISO-8859-1 for output instead of default UTF-8 -->
-  <xsl:param name="chunker.output.encoding" select="'ISO-8859-1'"/>
+  <xsl:param name="chunker.output.method" select="'xml'"/>
+  <xsl:param name="chunker.output.encoding" select="'UTF-8'"/>
+  <xsl:param name="chunker.output.media-type" select="'application/xhtml+xml'"/>
+  <xsl:param name="chunker.output.doctype-public" select="'-//W3C//DTD XHTML 1.0 Strict//EN'"/>
+  <xsl:param name="chunker.output.doctype-system" select="'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd'"/>
+  <xsl:param name="chunker.output.omit-xml-declaration" select="'yes'"/>
+  <xsl:param name="chunker.output.indent" select="'no'"/>
 
   <!-- Including our customized elements templates -->
@@ -34,7 +39,4 @@
   <xsl:param name="ulink.target" select="''"/>
   <xsl:param name="css.decoration" select="0"/>
-
-  <!-- No XML declaration -->
-  <xsl:param name="chunker.output.omit-xml-declaration" select="'yes'"/>
 
   <!-- Control generation of ToCs and LoTs -->
Index: stylesheets/lfs-xsl/chunkfast.xsl
===================================================================
--- stylesheets/lfs-xsl/chunkfast.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-xsl/chunkfast.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
Index: stylesheets/lfs-xsl/common.xsl
===================================================================
--- stylesheets/lfs-xsl/common.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-xsl/common.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
Index: stylesheets/lfs-xsl/nochunks.xsl
===================================================================
--- stylesheets/lfs-xsl/nochunks.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-xsl/nochunks.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
@@ -11,7 +11,11 @@
   <xsl:import href="http://docbook.sourceforge.net/release/xsl/current/xhtml/docbook.xsl"/>
 
-  <!-- Fix encoding issues with default UTF-8 output of the xhtml stylesheet -->
-  <xsl:output method="html" encoding="ISO-8859-1" indent="no" />
-
+  <xsl:output method="xml"
+              encoding="UTF-8"
+              media-type="application/xhtml+xml"
+              doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN"
+              doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"
+              omit-xml-declaration="yes"
+              indent="no" />
   <!-- Include our customized templates -->
   <xsl:include href="common.xsl"/>
Index: stylesheets/lfs-xsl/pdf.xsl
===================================================================
--- stylesheets/lfs-xsl/pdf.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-xsl/pdf.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
@@ -52,5 +52,7 @@
   <!-- Allow URLs to be automatically hyphenated.
        We have expanded the support to several inline tags.
-       See pdf/lfs-mixed.xsl -->
+       See pdf/lfs-mixed.xsl.
+       Note: the argument in select= is a zero-width space
+       (unicode 200b)-->
   <xsl:param name="ulink.hyphenate" select="'&#x200B;'"/>
 
Index: stylesheets/lfs-xsl/pdf/lfs-admon.xsl
===================================================================
--- stylesheets/lfs-xsl/pdf/lfs-admon.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-xsl/pdf/lfs-admon.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
Index: stylesheets/lfs-xsl/pdf/lfs-lists.xsl
===================================================================
--- stylesheets/lfs-xsl/pdf/lfs-lists.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-xsl/pdf/lfs-lists.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
@@ -50,5 +50,5 @@
                   keep-together.within-column="always" font-weight="bold"
                   keep-with-next.within-column="always" text-align="left">
-          <xsl:text>&#x2022;   </xsl:text>
+          <xsl:text>•   </xsl:text>
           <xsl:apply-templates select="term"/>
         </fo:block>
Index: stylesheets/lfs-xsl/pdf/lfs-mixed.xsl
===================================================================
--- stylesheets/lfs-xsl/pdf/lfs-mixed.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-xsl/pdf/lfs-mixed.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
Index: stylesheets/lfs-xsl/pdf/lfs-pagesetup.xsl
===================================================================
--- stylesheets/lfs-xsl/pdf/lfs-pagesetup.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-xsl/pdf/lfs-pagesetup.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
Index: stylesheets/lfs-xsl/pdf/lfs-xref.xsl
===================================================================
--- stylesheets/lfs-xsl/pdf/lfs-xref.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-xsl/pdf/lfs-xref.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,8 +1,6 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
-                xmlns:xlink="http://www.w3.org/1999/xlink"
                 xmlns:fo="http://www.w3.org/1999/XSL/Format"
-                exclude-result-prefixes="xlink"
                 version="1.0">
 
@@ -17,21 +15,11 @@
 
      <!--  xref:
-           Added role variable and use it when calling mode xref-to.-->
+           Added role variable and use it when calling mode xref-to.
+           Also remove code for xlink:href attribute in xref elements,
+           since we don't use it.-->
     <!-- The original template is in {docbook-xsl}/fo/xref.xsl -->
   <xsl:template match="xref" name="xref">
-    <xsl:param name="xhref" select="@xlink:href"/>
-    <!-- is the @xlink:href a local idref link? -->
-    <xsl:param name="xlink.idref">
-      <xsl:if test="starts-with($xhref,'#')
-                    and (not(contains($xhref,'&#40;'))
-                    or starts-with($xhref, '#xpointer&#40;id&#40;'))">
-        <xsl:call-template name="xpointer.idref">
-          <xsl:with-param name="xpointer" select="$xhref"/>
-        </xsl:call-template>
-    </xsl:if>
-    </xsl:param>
-    <xsl:param name="xlink.targets" select="key('id',$xlink.idref)"/>
     <xsl:param name="linkend.targets" select="key('id',@linkend)"/>
-    <xsl:param name="target" select="($xlink.targets | $linkend.targets)[1]"/>
+    <xsl:param name="target" select="$linkend.targets[1]"/>
     <xsl:param name="refelem" select="local-name($target)"/>
       <!-- Added role variable -->
@@ -90,5 +78,5 @@
             <xsl:message>
               <xsl:text>ERROR: xref linking to </xsl:text>
-              <xsl:value-of select="@linkend|@xlink:href"/>
+              <xsl:value-of select="@linkend"/>
               <xsl:text> has no generated link text.</xsl:text>
             </xsl:message>
Index: stylesheets/lfs-xsl/profile.xsl
===================================================================
--- stylesheets/lfs-xsl/profile.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-xsl/profile.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
@@ -19,4 +19,5 @@
   <!-- Generate DocBook instance with correct DOCTYPE -->
   <xsl:output method="xml"
+              encoding="UTF-8"
               doctype-public="-//OASIS//DTD DocBook XML V4.5//EN"
               doctype-system="http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd"/>
Index: stylesheets/lfs-xsl/xhtml/lfs-admon.xsl
===================================================================
--- stylesheets/lfs-xsl/xhtml/lfs-admon.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-xsl/xhtml/lfs-admon.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
Index: stylesheets/lfs-xsl/xhtml/lfs-legalnotice.xsl
===================================================================
--- stylesheets/lfs-xsl/xhtml/lfs-legalnotice.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-xsl/xhtml/lfs-legalnotice.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
Index: stylesheets/lfs-xsl/xhtml/lfs-mixed.xsl
===================================================================
--- stylesheets/lfs-xsl/xhtml/lfs-mixed.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-xsl/xhtml/lfs-mixed.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
@@ -295,5 +295,7 @@
         </xsl:when>
         <xsl:when test="$numcols &gt; 3">
-          <td>&#160;</td>
+        <!-- The space between <td> and </td> is a non breakable
+             space (unicode A0) encoded in utf-8.-->
+          <td> </td>
         </xsl:when>
         <xsl:otherwise/>
Index: stylesheets/lfs-xsl/xhtml/lfs-navigational.xsl
===================================================================
--- stylesheets/lfs-xsl/xhtml/lfs-navigational.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-xsl/xhtml/lfs-navigational.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
Index: stylesheets/lfs-xsl/xhtml/lfs-sections.xsl
===================================================================
--- stylesheets/lfs-xsl/xhtml/lfs-sections.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-xsl/xhtml/lfs-sections.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
@@ -12,8 +12,12 @@
 
     <!-- preface:
-           Output non sect1 child elements before the TOC -->
+         Output non sect1 child elements before the TOC
+         Output title outside of the <div> because we want to be able to
+         use it at a fixed position -->
     <!-- The original template is in {docbook-xsl}/xhtml/components.xsl -->
   <xsl:template match="preface">
     <xsl:call-template name="id.warning"/>
+    <xsl:call-template name="preface.titlepage"/>
+    <xsl:call-template name="component.separator"/>
     <div>
       <xsl:apply-templates select="." mode="class.attribute"/>
@@ -27,6 +31,4 @@
         </xsl:attribute>
       </xsl:if>
-      <xsl:call-template name="component.separator"/>
-      <xsl:call-template name="preface.titlepage"/>
       <xsl:apply-templates/>
       <xsl:variable name="toc.params">
@@ -45,9 +47,40 @@
   </xsl:template>
 
+    <!-- part:
+         Output non sect1 child elements before the TOC
+         Output title outside of the <div> because we want to be able to
+         use it at a fixed position -->
+    <!-- The original template is in {docbook-xsl}/xhtml/divisions.xsl -->
+  <xsl:template match="part">
+    <xsl:call-template name="id.warning"/>
+
+    <xsl:call-template name="part.titlepage"/>
+
+    <div>
+      <xsl:apply-templates select="." mode="common.html.attributes"/>
+      <xsl:call-template name="id.attribute">
+        <xsl:with-param name="conditional" select="0"/>
+      </xsl:call-template>
+
+      <xsl:apply-templates/>
+      <xsl:variable name="toc.params">
+        <xsl:call-template name="find.path.params">
+          <xsl:with-param name="table" select="normalize-space($generate.toc)"/>
+        </xsl:call-template>
+      </xsl:variable>
+      <xsl:if test="not(partintro) and contains($toc.params, 'toc')">
+        <xsl:call-template name="division.toc"/>
+      </xsl:if>
+    </div>
+  </xsl:template>
+
     <!-- chapter:
-           Output non sect1 child elements before the TOC -->
+           Output non sect1 child elements before the TOC
+           Output title before div to be able to fix the title position -->
     <!-- The original template is in {docbook-xsl}/xhtml/components.xsl -->
   <xsl:template match="chapter">
     <xsl:call-template name="id.warning"/>
+    <xsl:call-template name="chapter.titlepage"/>
+    <xsl:call-template name="component.separator"/>
     <div>
       <xsl:apply-templates select="." mode="class.attribute"/>
@@ -61,6 +94,4 @@
         </xsl:attribute>
       </xsl:if>
-      <xsl:call-template name="component.separator"/>
-      <xsl:call-template name="chapter.titlepage"/>
       <xsl:apply-templates/>
       <xsl:variable name="toc.params">
@@ -79,10 +110,48 @@
   </xsl:template>
 
+    <!-- appendix:
+           Output non sect1 child elements before the TOC
+           Output title before div to be able to fix the title position -->
+    <!-- The original template is in {docbook-xsl}/xhtml/components.xsl -->
+  <xsl:template match="appendix">
+
+    <xsl:call-template name="id.warning"/>
+
+    <xsl:call-template name="appendix.titlepage"/>
+
+    <xsl:element name="div" namespace="http://www.w3.org/1999/xhtml">
+      <xsl:call-template name="common.html.attributes">
+        <xsl:with-param name="inherit" select="1"/>
+      </xsl:call-template>
+      <xsl:call-template name="id.attribute">
+        <xsl:with-param name="conditional" select="0"/>
+      </xsl:call-template>
+
+      <xsl:apply-templates/>
+
+      <xsl:variable name="toc.params">
+        <xsl:call-template name="find.path.params">
+          <xsl:with-param name="table" select="normalize-space($generate.toc)"/>
+        </xsl:call-template>
+      </xsl:variable>
+
+      <xsl:if test="contains($toc.params, 'toc')">
+        <xsl:call-template name="component.toc">
+          <xsl:with-param name="toc.title.p" select="contains($toc.params, 'title')"/>
+        </xsl:call-template>
+      </xsl:if>
+
+    </xsl:element>
+  </xsl:template>
+
     <!-- sect1:
            When there is a role attibute, use it as the class value.
            Process the SVN keywords found in sect1info as a footnote.
+           Output title before the containing <div> so that the title
+           can be at a fixed position.
            Removed unused code. -->
     <!-- The original template is in {docbook-xsl}/xhtml/sections.xsl -->
   <xsl:template match="sect1">
+    <xsl:call-template name="sect1.titlepage"/>
     <div>
       <xsl:choose>
@@ -97,5 +166,4 @@
       </xsl:choose>
       <xsl:call-template name="language.attribute"/>
-      <xsl:call-template name="sect1.titlepage"/>
       <xsl:apply-templates/>
       <xsl:apply-templates select="sect1info" mode="svn-keys"/>
Index: stylesheets/lfs-xsl/xhtml/lfs-titles.xsl
===================================================================
--- stylesheets/lfs-xsl/xhtml/lfs-titles.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-xsl/xhtml/lfs-titles.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
Index: stylesheets/lfs-xsl/xhtml/lfs-toc.xsl
===================================================================
--- stylesheets/lfs-xsl/xhtml/lfs-toc.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-xsl/xhtml/lfs-toc.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
Index: stylesheets/lfs-xsl/xhtml/lfs-xref.xsl
===================================================================
--- stylesheets/lfs-xsl/xhtml/lfs-xref.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/lfs-xsl/xhtml/lfs-xref.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,8 +1,6 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
-                xmlns:xlink="http://www.w3.org/1999/xlink"
                 xmlns="http://www.w3.org/1999/xhtml"
-                exclude-result-prefixes="xlink"
                 version="1.0">
 
@@ -16,20 +14,11 @@
 
     <!-- xref:
-           Added role variable and use it when calling mode xref-to.-->
+           Added role variable and use it when calling mode xref-to.
+           Also remove code for xlink:href attributes in xref elements
+           since we don't use it.-->
     <!-- The original template is in {docbook-xsl}/xhtml/xref.xsl -->
   <xsl:template match="xref" name="xref">
-    <xsl:param name="xhref" select="@xlink:href"/>
-    <!-- is the @xlink:href a local idref link? -->
-    <xsl:param name="xlink.idref">
-      <xsl:if test="starts-with($xhref,'#') and (not(contains($xhref,'('))
-                    or starts-with($xhref, '#xpointer(id('))">
-        <xsl:call-template name="xpointer.idref">
-          <xsl:with-param name="xpointer" select="$xhref"/>
-        </xsl:call-template>
-      </xsl:if>
-    </xsl:param>
-    <xsl:param name="xlink.targets" select="key('id',$xlink.idref)"/>
     <xsl:param name="linkend.targets" select="key('id',@linkend)"/>
-    <xsl:param name="target" select="($xlink.targets | $linkend.targets)[1]"/>
+    <xsl:param name="target" select="$linkend.targets[1]"/>
       <!-- Added role variable -->
     <xsl:variable name="role" select="@role"/>
@@ -86,5 +75,5 @@
           <xsl:message>
             <xsl:text>ERROR: xref linking to </xsl:text>
-            <xsl:value-of select="@linkend|@xlink:href"/>
+            <xsl:value-of select="@linkend"/>
             <xsl:text> has no generated link text.</xsl:text>
           </xsl:message>
Index: stylesheets/md5sum.xsl
===================================================================
--- stylesheets/md5sum.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/md5sum.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,8 +1,8 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
-<!-- Create a md5 list for packages and pathces used. -->
+<!-- Create a md5 list for packages and patches used. -->
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
-    version="1.0">
+                version="1.0">
 
   <xsl:output method="text"/>
@@ -32,5 +32,5 @@
 
       <!-- Add a newline -->
-      <xsl:text>&#x0a;</xsl:text>
+      <xsl:text>&#xA;</xsl:text>
 
     </xsl:if>
@@ -56,3 +56,2 @@
 
 </xsl:stylesheet>
-
Index: stylesheets/patcheslist.xsl
===================================================================
--- stylesheets/patcheslist.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/patcheslist.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 <!DOCTYPE xsl:stylesheet [
  <!ENTITY % general-entities SYSTEM "../general.ent">
@@ -23,24 +23,28 @@
 }
 
-umask 002 &#x0a;&#x0a;</xsl:text>
+umask 002
 
-      <!-- Create dest.dir if it don't exist -->
-    <xsl:text>install -d -m 775 -g lfswww </xsl:text>
+# Create dest.dir if it doesn't exist
+# Remove old patches
+# Copy the patches
+# Ensure correct ownership
+install -d -m 775 -g lfswww </xsl:text>
     <xsl:value-of select="$dest.dir"/>
-    <xsl:text> &amp;&amp;&#x0a;</xsl:text>
-    <xsl:text>cd </xsl:text>
+    <xsl:text> &amp;&amp;
+cd </xsl:text>
     <xsl:value-of select="$dest.dir"/>
-    <xsl:text> &amp;&amp;&#x0a;&#x0a;</xsl:text>
-      <!-- Remove old patches -->
-    <xsl:text>rm -f *.patch copyerrs &amp;&amp; &#x0a;&#x0a;</xsl:text>
+    <xsl:text> &amp;&amp;
+rm -f *.patch copyerrs &amp;&amp;
+
+</xsl:text>
     <xsl:apply-templates/>
-      <!-- Ensure correct owneship -->
-    <xsl:text>&#x0a;chgrp lfswww *.patch &amp;&amp;&#x0a;</xsl:text>
     <xsl:text>
+chgrp lfswww *.patch &amp;&amp;
 if [ `wc -l copyerrs | sed 's/ *//' | cut -f1 -d' '` -gt 0 ]; then
   mail -s "Missing LFS patches" lfs-book@lists.linuxfromscratch.org &lt; copyerrs
-fi&#x0a;&#x0a;</xsl:text>
+fi
 
-    <xsl:text>exit&#x0a;</xsl:text>
+exit
+</xsl:text>
   </xsl:template>
 
@@ -60,8 +64,9 @@
       </xsl:variable>
       <xsl:text>copy /srv/www/www.linuxfromscratch.org/patches/downloads/</xsl:text>
-          <xsl:value-of select="substring-before($patch.name2, '-0')"/>
+      <xsl:value-of select="substring-before($patch.name2, '-0')"/>
       <xsl:text>/</xsl:text>
       <xsl:value-of select="$patch.name"/>
-      <xsl:text> . &#x0a;</xsl:text>
+      <xsl:text> .
+</xsl:text>
     </xsl:if>
   </xsl:template>
Index: stylesheets/wget-list.xsl
===================================================================
--- stylesheets/wget-list.xsl	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ stylesheets/wget-list.xsl	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -1,3 +1,3 @@
-<?xml version='1.0' encoding='ISO-8859-1'?>
+<?xml version='1.0' encoding='UTF-8'?>
 
 <!-- Create a list of upstream URLs for packages and patches to be used
@@ -5,5 +5,5 @@
 
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
-    version="1.0">
+                version="1.0">
 
   <xsl:output method="text"/>
@@ -29,5 +29,5 @@
         </xsl:otherwise>
       </xsl:choose>
-      <xsl:text>&#x0a;</xsl:text>
+      <xsl:text>&#xA;</xsl:text>
     </xsl:if>
   </xsl:template>
Index: tidy.conf
===================================================================
--- tidy.conf	(revision e49e2ea26119d5fe32b5d37ef0cac553944f9fa0)
+++ tidy.conf	(revision 9e76c64bee29fcf6d7f31ac5fcf32dca365a318d)
@@ -2,6 +2,4 @@
 wrap: 78
 tab-size: 8
-input-encoding: latin1
-output-encoding: latin1
 write-back: yes
 markup: yes
